function MillGUIModule.CycleStartInhibitDialog()
	local a,b,c
	local FunctionName = "CycleStartInhibitDialog"
	local FileName = "MillMCodeModule"
	local AlarmMessageString = ""
	local AlarmMessageArray = {}
	local AlarmMessageCount = nil
	local AlarmMessageDialogTitle = "Inhibit Cycle Start Messages"
	
	--AlarmMessageString = " Alarm 1 "--, Alarm 2 ,Alarm 3,Alarm 4,Alarm 5"
	
	AlarmMessageString = w.GetRegValueString("MachMotion", "mm_FaultMessages") 
	
	AlarmMessageArray, AlarmMessageCount = w.ParseCSVLine(AlarmMessageString,",")
	
	for i = 1, AlarmMessageCount do
		local tempstring 
		local tempstringlength = string.len(AlarmMessageArray[i])
		
		tempstring = string.sub(AlarmMessageArray[i], 0, 1)
		
		if tempstring == " " then
			tempstring = string.sub(AlarmMessageArray[i], 2)
			AlarmMessageArray[i] = tempstring
		end
		
		tempstring = string.sub(AlarmMessageArray[i], 0, 21)
		
		if tempstring == "Inhibit Cycle Start: " then
			tempstring = string.sub(AlarmMessageArray[i], 22)
			AlarmMessageArray[i] = tempstring
		end
		
		tempstring = string.sub(AlarmMessageArray[i], 0, 31)
		
		if tempstring == "Inhibit Cycle Start (Enabled): " then
			tempstring = string.sub(AlarmMessageArray[i], 32)
			AlarmMessageArray[i] = tempstring
		end
		
		tempstringlength = string.len(AlarmMessageArray[i])
		tempstring = string.sub(AlarmMessageArray[i], tempstringlength -1, tempstringlength)
		if tempstring == " " then
			tempstring = string.sub(AlarmMessageArray[i], tempstringlength -1, tempstringlength)
			AlarmMessageArray[i] = tempstring
		end
	end
	
	if AlarmMessageCount == 0 or AlarmMessageCount == nil then
		wx.wxMessageBox("Emty String")
		return nil, false, w.FunctionError("Emty String")
	end
	
	if DIALOG_IS_OPEN[5] == true then
		return nil, false, w.FunctionError("Dialog Is Already Open")
	end
	
	DIALOG_IS_OPEN[5] = true
		
	-- create ListAlarmMessageBox
	local UI = {}

	UI.ListAlarmMessageDialog = wx.wxDialog (wx.NULL, wx.wxID_ANY, AlarmMessageDialogTitle, wx.wxDefaultPosition, wx.wxSize( -1,-1 ), wx.wxDEFAULT_DIALOG_STYLE )
	UI.ListAlarmMessageDialog:SetSizeHints( wx.wxDefaultSize, wx.wxDefaultSize )
	
	UI.bSizer1 = wx.wxBoxSizer( wx.wxVERTICAL )
	
	UI.m_staticText3 = wx.wxStaticText( UI.ListAlarmMessageDialog, wx.wxID_ANY, "One or more user 'Inhibit Cycle Start' messages are active.  Clear messages before pressing 'Cycle Start'.", wx.wxDefaultPosition, wx.wxDefaultSize, wx.wxALIGN_CENTRE )
	UI.m_staticText3:Wrap( 250 )
	UI.m_staticText3:SetFont( wx.wxFont( 12, 74, 90, 90, False, "Arial" ) )
	UI.m_staticText3:SetForegroundColour( wx.wxColour( 255, 0, 0 ) )
	
	UI.bSizer1:Add( UI.m_staticText3, 0, wx.wxALL + wx.wxALIGN_CENTER_HORIZONTAL, 5 )
	
	UI.fgSizer1 = wx.wxFlexGridSizer( 0, 2, 0, 0 )
	UI.fgSizer1:SetFlexibleDirection( wx.wxBOTH )
	UI.fgSizer1:SetNonFlexibleGrowMode( wx.wxFLEX_GROWMODE_SPECIFIED )
	
	UI.AlarmsGrid = wx.wxGrid( UI.ListAlarmMessageDialog, wx.wxID_ANY, wx.wxDefaultPosition, wx.wxDefaultSize, 0 )
	
	-- Grid
	UI.AlarmsGrid:CreateGrid( AlarmMessageCount, 1 )
	UI.AlarmsGrid:EnableEditing( false )
	UI.AlarmsGrid:EnableGridLines( true )
	UI.AlarmsGrid:EnableDragGridSize( false )
	UI.AlarmsGrid:SetMargins( 0, 0 )
	
	-- Columns
	UI.AlarmsGrid:SetColSize( 0, 300 )
	UI.AlarmsGrid:EnableDragColSize( false )
	UI.AlarmsGrid:SetColLabelSize( 30 )
	UI.AlarmsGrid:SetColLabelValue( 0, "Inhibit Messages" )
	UI.AlarmsGrid:SetColLabelAlignment( wx.wxALIGN_CENTRE, wx.wxALIGN_CENTRE )
	
	-- Rows
	UI.AlarmsGrid:EnableDragRowSize( true )
	UI.AlarmsGrid:SetRowLabelSize( 25 )
	UI.AlarmsGrid:SetRowLabelAlignment( wx.wxALIGN_CENTRE, wx.wxALIGN_CENTRE )
	
	-- Label Appearance
	
	-- Cell Defaults
	UI.AlarmsGrid:SetDefaultCellAlignment( wx.wxALIGN_LEFT, wx.wxALIGN_TOP )
	UI.fgSizer1:Add( UI.AlarmsGrid, 0, wx.wxALL + wx.wxEXPAND, 5 )
	
	
	UI.bSizer1:Add( UI.fgSizer1, 0, wx.wxALIGN_CENTER_HORIZONTAL + wx.wxALL, 5 )
	
	UI.bSizer4 = wx.wxBoxSizer( wx.wxVERTICAL )
	
	UI.m_staticline1 = wx.wxStaticLine( UI.ListAlarmMessageDialog, wx.wxID_ANY, wx.wxDefaultPosition, wx.wxDefaultSize, wx.wxLI_HORIZONTAL )
	UI.bSizer4:Add( UI.m_staticline1, 0, wx.wxALL + wx.wxEXPAND, 5 )
	
	UI.OKButton = wx.wxButton( UI.ListAlarmMessageDialog, wx.wxID_ANY, "OK", wx.wxDefaultPosition, wx.wxSize( 100,45 ), 0 )
	UI.OKButton:SetFont( wx.wxFont( 15, 70, 90, 90, False, "" ) )
	
	UI.bSizer4:Add( UI.OKButton, 0, wx.wxALIGN_CENTER_HORIZONTAL + wx.wxBOTTOM + wx.wxRIGHT + wx.wxLEFT, 5 )
	
	
	UI.bSizer1:Add( UI.bSizer4, 0, wx.wxALIGN_CENTER_HORIZONTAL + wx.wxEXPAND, 5 )
	
	UI.AlarmsGrid:EnableGridLines( true )
	UI.ListAlarmMessageDialog:SetSizer( UI.bSizer1 )
	UI.ListAlarmMessageDialog:Layout()
	UI.bSizer1:Fit( UI.ListAlarmMessageDialog )
	
	UI.ListAlarmMessageDialog:Centre( wx.wxBOTH )
	
	-- Connect Events

	local ListAlarmMessageTimer = wx.wxTimer(UI.ListAlarmMessageDialog)
		UI.ListAlarmMessageDialog:Connect(wx.wxEVT_TIMER, function(event)
		
		if ListAlarmMessageTimer then
			ListAlarmMessageTimer:Stop()
		end
		
		local a,b,c = w.GetRegValueString("MachMotion","mm_ConfigEnd")
		if b ~= true then
			CloseDialog() -- Then mach must be shut down.
		end	
		
		event:Skip()
	end) 	

	UI.ListAlarmMessageDialog:Connect( wx.wxEVT_CLOSE_WINDOW, function(event)
		CloseDialog(true)
		event:Skip()
	end)
	
	UI.OKButton:Connect( wx.wxEVT_COMMAND_BUTTON_CLICKED, function(event)
	--implements OKButtonOnButtonClick
		CloseDialog()
	event:Skip()
	end)
	
	function UpdateRows(MessageArray, RowNum)
		for i = 0, RowNum -1 do
			UI.AlarmsGrid:SetCellValue(i,0, tostring(MessageArray[i+1]));
			UI.AlarmsGrid:SetReadOnly(i, 0, true)
		end
	end
	
	function CloseDialog(CloseWindow)
		if ListAlarmMessageTimer then
			ListAlarmMessageTimer:Stop()
			ListAlarmMessageTimer:delete()
		end	
		DIALOG_IS_OPEN[5] = false
		UI.ListAlarmMessageDialog:EndModal(1)
		
		if CloseWindow ~= true then
			UI.ListAlarmMessageDialog:Destroy()
		end
	end	

	UpdateRows(AlarmMessageArray, AlarmMessageCount)
	
	UI.ListAlarmMessageDialog:Layout()
	UI.bSizer1:Fit( UI.ListAlarmMessageDialog )
	--
	UI.ListAlarmMessageDialog:Centre( wx.wxBOTH )
	
	
	ListAlarmMessageTimer:Start(100)
	
	UI.ListAlarmMessageDialog:ShowModal()
end